﻿using Hotline.CallCenter.Configs;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using SqlSugar;

namespace Hotline.Repository.SqlSugar.Extensions;

public static class XingTangDbExtensions
{
    public static IServiceCollection AddXingTangDb(this IServiceCollection services, XingTangConfiguration xingTangConfiguration)
    {
        SqlSugarScope sqlSugar = new SqlSugarScope(new ConnectionConfig()
        {
            DbType = DbType.MySql,
            ConnectionString = xingTangConfiguration.DbConnectionString,
            IsAutoCloseConnection = true,
        },
             db => { }
         );

        ISugarUnitOfWork<XingTangDbContext> context = new SugarUnitOfWork<XingTangDbContext>(sqlSugar);
        services.AddSingleton(context);

        return services;
    }
}